#define MMR_BASE 0xFFFF0000

#define T0LD (MMR_BASE + 0x0300)
#define T0VAL (MMR_BASE + 0x0304)
#define T0CON (MMR_BASE + 0x0308)
#define T0CLRI (MMR_BASE + 0x030C)

#define GP0CON (MMR_BASE + 0xF400)
#define GP0DAT (MMR_BASE + 0xF420)
#define GP0SET (MMR_BASE + 0xF424)
#define GP0CLR (MMR_BASE + 0xF428)

#define GP4CON (MMR_BASE + 0xF410)
#define GP4DAT (MMR_BASE + 0xF460)
#define GP4SET (MMR_BASE + 0xF464)
#define GP4CLR (MMR_BASE + 0xF468)

#define IRQSTA (MMR_BASE + 0x0000)
#define IRQSIG (MMR_BASE + 0x0004)
#define IRQEN (MMR_BASE + 0x0008)
#define IRQCLR (MMR_BASE + 0x000C)


extern volatile short led_state;

//_ŎԂ̏l
//0x4FA6ɂ1bŏC1bœ_
#define TIMER_INIT_VAL 0x4FA6
// _Ԋu̍ŏl
#define TIMER_MIN_VAL 0x100

volatile int TIMER_VAL;

// {^Őݒł鉺l
// 荞݃nh
void IRQ_function(){

  // IRQWX^ւ̃|C^
  volatile unsigned int *irqsig;
  // Timer0WX^ւ̃|C^
  volatile unsigned int *t0ld, *t0con, *t0clr;
  // GPIOݒ背WX^ւ̃|C^
  volatile unsigned int *gp4con, *gp4dat;
  
  // IRQ̃WX^̃|C^ݒ
  irqsig = (unsigned int *)IRQSIG;

  gp4con = (unsigned int *)GP4CON;
  gp4dat = (unsigned int *)GP4DAT;
  
  if(*irqsig & (1<<2)){ // Timer0IRQ
    // Timer0̃WX^̃|C^ݒ
    t0ld = (unsigned int *)T0LD;
    t0con = (unsigned int *)T0CON;
    t0clr = (unsigned int *)T0CLRI;
    
    // LED𔽓]
    // GP4DATWX^P4.7𔽓](read onlỷ16rbg͉Ă悢)
    if(led_state == 0){ // 
      *gp4dat = 0xFF7F0000; // _
      led_state = 1;
    }
    else{ // 
      *gp4dat = 0xFFFF0000; // 
      led_state = 0;
    }
    
    // Timer0IRQNA
    *t0clr = 1; // ̒lł悢珑
    // ^C}̏lݒ
    *t0ld = TIMER_VAL; 
    // Core clock1/16ɐݒ肵CTimer0X^[g
    *t0con = (1<<7) | (1 << 3);
    
  }
}
